#ifndef SLTHREAD_H
#define SLTHREAD_H

using namespace std;

#ifdef SLABBER_SHM

extern unsigned numThreads;

class Calculation;

struct ThreadInfo
{
  unsigned threadIndex;
  Calculation * calculation;
};

#if __cplusplus >= 201103L

#include <thread>
#include <atomic>
#include <chrono>

struct ThreadInfo;

extern thread_local ThreadInfo * threadInfo;

extern atomic <unsigned> threadBarrierCount1, threadBarrierCount2;

inline ThreadInfo & getThreadInfo ()  {return * threadInfo;}

inline void threadBarrier1 ()
{ if (threadBarrierCount1 ++ == numThreads - 1)  threadBarrierCount1 = 0;
  else while (threadBarrierCount1 != 0);
}

inline void threadBarrier2 ()
{ if (threadBarrierCount2 ++ == numThreads - 1)  threadBarrierCount2 = 0;
  else while (threadBarrierCount2 != 0);
}

#else  // not C++11

#include <pthread.h>

extern pthread_key_t threadInfoKey;
extern pthread_barrier_t threadBarrier;

inline ThreadInfo & getThreadInfo ()
  {return * reinterpret_cast <ThreadInfo *> (pthread_getspecific (threadInfoKey));}

inline void threadBarrier1 ()  {pthread_barrier_wait (& threadBarrier);}
inline void threadBarrier2 ()  {pthread_barrier_wait (& threadBarrier);}

#endif  // Posix/C++11

#endif

#endif

