#ifndef VARIABLE_H
#define VARIABLE_H
#include <vector>

class Operator;
class Calculation;

class Variable
{
public:
  Variable (Operator * poperator, unsigned poperand, Calculation * pcalculation)
  { sourceOperator = poperator;
    sourceOperand = poperand;
    calculation = pcalculation;
    transposed = false;
    reference = 0;
  }

  Variable (Variable & ref, bool ptransposed)
  { sourceOperator = 0;  sourceOperand = 0;
    calculation = ref . calculation;
    transposed = ptransposed;
    reference = & ref;
  }

  Variable (Variable & v);  // implemented in operator.h

  Variable & operator= (Variable & v);  // implemented in operator.h

  void print (ostream & o);  // implemented in operator.h

  Operator * sourceOperator;
  unsigned sourceOperand;
  std :: vector <Operator *> destOperators;
  std :: vector <unsigned> destOperands;
  Calculation * calculation;
  bool transposed;
  Variable * reference;
};


inline ostream & operator<< (ostream & o, Variable & v)
  {v . print (o);  return o;}


#endif

